package com.yice.webadmin.app.controller;

import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.github.pagehelper.page.PageMethod;
import com.yice.webadmin.app.vo.*;
import com.yice.webadmin.app.dto.*;
import com.yice.webadmin.app.model.*;
import com.yice.webadmin.app.service.*;
import com.yice.common.core.object.*;
import com.yice.common.core.util.*;
import com.yice.common.core.constant.*;
import com.yice.common.core.annotation.MyRequestBody;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * 模型任务操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "模型任务管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/modelTask")
public class ModelTaskController {

    @Autowired
    private ModelTaskService modelTaskService;

    /**
     * 新增模型任务数据。
     *
     * @param modelTaskDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"modelTaskDto.taskId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody ModelTaskDto modelTaskDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(modelTaskDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        ModelTask modelTask = MyModelUtil.copyTo(modelTaskDto, ModelTask.class);
        modelTask = modelTaskService.saveNew(modelTask);
        return ResponseResult.success(modelTask.getTaskId());
    }

    /**
     * 更新模型任务数据。
     *
     * @param modelTaskDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody ModelTaskDto modelTaskDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(modelTaskDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        ModelTask modelTask = MyModelUtil.copyTo(modelTaskDto, ModelTask.class);
        ModelTask originalModelTask = modelTaskService.getById(modelTask.getTaskId());
        if (originalModelTask == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!modelTaskService.update(modelTask, originalModelTask)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除模型任务数据。
     *
     * @param taskId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long taskId) {
        if (MyCommonUtil.existBlankArgument(taskId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(taskId);
    }

    /**
     * 列出符合过滤条件的模型任务列表。
     *
     * @param modelTaskDtoFilter 过滤对象。
     * @param orderParam 排序参数。
     * @param pageParam 分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<ModelTaskVo>> list(
            @MyRequestBody ModelTaskDto modelTaskDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        ModelTask modelTaskFilter = MyModelUtil.copyTo(modelTaskDtoFilter, ModelTask.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, ModelTask.class);
        List<ModelTask> modelTaskList = modelTaskService.getModelTaskListWithRelation(modelTaskFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(modelTaskList, ModelTask.INSTANCE));
    }

    /**
     * 查看指定模型任务对象详情。
     *
     * @param taskId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<ModelTaskVo> view(@RequestParam Long taskId) {
        ModelTask modelTask = modelTaskService.getByIdWithRelation(taskId, MyRelationParam.full());
        if (modelTask == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        ModelTaskVo modelTaskVo = ModelTask.INSTANCE.fromModel(modelTask);
        return ResponseResult.success(modelTaskVo);
    }

    private ResponseResult<Void> doDelete(Long taskId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        ModelTask originalModelTask = modelTaskService.getById(taskId);
        if (originalModelTask == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!modelTaskService.remove(taskId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
